<template>
  <div ref="wrapper">
    <div class="form-field time">
      <span>{{ $t("restaurantPreorderTimeSelector.label") }}</span>
    </div>
    <div class="content">
      <div class="time-selector">
        <time-select
          ref="select"
          @toggle="timeSelectorOpened = !timeSelectorOpened"
          :value="selectorValue"
          :opened="timeSelectorOpened"
          :disabled="disabled"
          :disabledMessage="disabledMessage"
        />
        <date-selector
          v-if="timeSelectorOpened"
          @close="timeSelectorOpened = false"
          @dateChanged="date => $emit('dateChanged', date)"
          @timeChanged="time => $emit('timeChanged', time)"
          :time="time"
          :date="date"
          :times="times"
          :dates="dates"
        />
        <div
          class="desc"
          v-html="$t(`${restaurantTimeSelectorScope}.desc`)"
        ></div>
      </div>
    </div>
    <div
      class="fixed"
      :class="{ show: !visible && isMobile, opend: timeSelectorOpened }"
      @click="timeSelectorOpened = false"
    >
      <div class="time-selector" @click.stop>
        <div class="fixed-selector-toogle">
          <span class="fixed-selector-label">{{
            $t(`${restaurantTimeSelectorScope}.time`)
          }}</span>
          <div class="fixed-selector-select">
            <time-select
              ref="fixedSelect"
              @toggle="timeSelectorOpened = !timeSelectorOpened"
              :value="selectorValue"
              :opened="timeSelectorOpened"
            />
          </div>
        </div>
        <date-selector
          v-if="timeSelectorOpened"
          @close="timeSelectorOpened = false"
          @dateChanged="date => $emit('dateChanged', date)"
          @timeChanged="time => $emit('timeChanged', time)"
          :time="time"
          :date="date"
          :times="times"
          :dates="dates"
        />
        <div
          class="desc"
          v-html="$t(`${restaurantTimeSelectorScope}.desc`)"
        ></div>
      </div>
    </div>
    <div class="form-field order">
      <span>{{ $t("restaurantPreorderTimeSelector.order") }}</span>
    </div>
  </div>
</template>

<script>
import moment from "moment";
import { mapState } from "vuex";
import TimeSelect from "./TimeSelect";
import * as groupPresenter from "@/presenters/group";
import DateSelector from "@/components/Group/DateSelector";

export default {
  components: {
    TimeSelect,
    DateSelector
  },

  props: {
    times: {
      type: Array,
      default: () => []
    },

    time: {
      type: String
    },

    dates: {
      type: Array,
      default: () => []
    },

    date: {
      type: Date
    },

    preorderStarted: {
      type: Boolean,
      default: false
    },

    disabled: {
      type: Boolean,
      default: false
    }
  },

  data() {
    return {
      visible: false,
      timeSelectorOpened: false
    };
  },

  computed: {
    ...mapState(["isMobile"]),

    today() {
      return moment().format("M/D");
    },

    disabledMessage() {
      return this.preorderStarted
        ? this.$t("restaurantPreorderTimeSelector.closed")
        : this.$t("restaurantPreorderTimeSelector.unavailable");
    },

    selectorValue() {
      return groupPresenter.formatDate(this.date) + " " + this.time;
    },

    isPreorder() {
      return this.$route.name === "RestaurantPreorder";
    },

    isDelivery() {
      return this.$route.name === "RestaurantDelivery";
    },

    restaurantTimeSelectorScope() {
      return this.isPreorder
        ? "restaurantPreorderTimeSelector"
        : this.isDelivery
        ? "restaurantDeliveryTimeSelector"
        : "";
    }
  },

  methods: {
    checkTime() {
      if (!this.time && this.times.length) {
        this.$emit("timeChanged", this.times[0]);
      }
    },

    checkPosition() {
      window.requestAnimationFrame(() => {
        const visible = elementInViewport(this.$refs.wrapper);
        if (this.visible !== visible) {
          this.visible = visible;
        }
      });
    }
  },

  mounted() {
    window.addEventListener("resize", this.checkPosition);
    window.addEventListener("scroll", this.checkPosition);
    this.checkPosition();
    this.checkTime();
  },

  updated() {
    this.checkTime();
  },

  destroyed() {
    window.removeEventListener("resize", this.checkPosition);
    window.removeEventListener("scroll", this.checkPosition);
  }
};

function elementInViewport(el) {
  if (!el) {
    return;
  }

  var top = el.offsetTop;
  var left = el.offsetLeft;
  var width = el.offsetWidth;
  var height = el.offsetHeight;

  while (el.offsetParent) {
    el = el.offsetParent;
    top += el.offsetTop;
    left += el.offsetLeft;
  }

  return top >= window.pageYOffset;
}
</script>

<style lang="scss" scoped>
.content {
  padding: 0 10px;
}

.form-field {
  position: relative;

  span {
    vertical-align: middle;
  }

  &::before {
    content: "";
    display: inline-block;
    border-radius: 50%;
    width: 20px;
    height: 20px;
    text-align: center;
    line-height: 20px;
    background: $color-secondary-black;
    vertical-align: middle;
    margin-right: 10px;
    color: $color-white;
    font-size: 12px;
  }

  &.time::before {
    content: "1";
  }

  &.order::before {
    content: "2";
  }
}

.time-selector {
  padding: 10px 0 40px;

  .desc {
    font-size: 12px;
    color: $color-primary-grey;
    margin-top: 10px;
  }

  @include media-breakpoint-up(md) {
    padding-top: 20px;
  }
}

.fixed {
  position: fixed;
  z-index: -1;
  top: 0;
  left: 0;
  width: 100%;
  opacity: 0;
  transition: opacity 0.2s;

  &.show {
    z-index: 2;
    opacity: 1;
  }

  &.opend {
    height: 100%;
    background: rgba(0, 0, 0, 0.5);
  }

  .time-selector {
    background: $color-white;
    padding: 6px 30px 20px;
    box-sizing: border-box;
    box-shadow: 0 4px 12px rgba(0, 0, 0, 0.1);
  }
}

.fixed-selector-label {
  display: block;
  white-space: nowrap;
  margin: 4px 0 6px;
  font-size: 16px;
}

.fixed-selector-select {
  width: 100%;
}

.today-label {
  margin-top: 20px;
  font-size: 14px;
}
</style>
